import tkinter as tk
import math
import random


class Balls:
    def __init__(self,x,y,dx,dy,color,n,r):
        self.x=x
        self.y=y
        self.dx=dx
        self.dy=dy
        self.color=color
        self.n=n
        self.r=r

    def move(self):
        canvas.delete(self.n)     
        self.x=self.x+self.dx
        self.y=self.y+self.dy
        self.n=canvas.create_oval(self.x-self.r,self.y-self.r,self.x+self.r,self.y+self.r,fill=self.color,width=0)

        if self.x<0 or canvas.winfo_width()<self.x:
            self.dx=-self.dx
        if self.y<0 or canvas.winfo_height()<self.y:
            self.dy=-self.dy
    
    def bound():
        for a in balls:
            for b in balls:
                l=(a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)
                if 0<l<=4*a.r*a.r:
                    m=(complex(a.dx,a.dy)/abs(complex(a.dx,a.dy)))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    n=m*m
                    p=-n.real
                    q=n.imag
                    s=complex(p,q)
                    t=complex(a.dx,a.dy)*s
                    a.dx=t.real
                    a.dy=t.imag
                    
                    

class Ball:
    def __init__(self,x,y,o,t,T,X,Y):
        self.x=x
        self.y=y
        self.o=o
        self.t=t
        self.T=T
        self.X=X
        self.Y=Y

    def click_and_move(self):
        if self.x!=None and self.y!=None:
            canvas.delete(self.o)
            self.o=canvas.create_oval(self.x-50,self.y-50,self.x+50,self.y+50,fill="#000000",width=0)
            if self.x<=0 or canvas.winfo_width()<=self.x or self.y<=0 or canvas.winfo_height()<=self.y:
                self.X=-self.X
                self.Y=-self.Y
                self.T=-self.T
            else:
                self.t=self.t+self.T
            self.x=self.x-self.X*3*math.sin(self.t)
            self.y=self.y-self.Y*3*math.cos(self.t)
                
    def click(self,event):
        self.x=event.x
        self.y=event.y
        self.t=-3.14159265/2
        


balls=[
    Balls(120,80,random.choice([-2,2]),random.choice([-2,2]),"#FF0000",None,50),
    Balls(180,620,random.choice([-2,2]),random.choice([-2,2]),"#FFFF00",None,50),
    Balls(720,80,random.choice([-2,2]),random.choice([-2,2]),"#FF00FF",None,50),
    Balls(780,620,random.choice([-2,2]),random.choice([-2,2]),"#00FF00",None,50),
    Balls(350,350,random.choice([-2,2]),random.choice([-2,2]),"#00FFFF",None,50),
    Balls(550,350,random.choice([-2,2]),random.choice([-2,2]),"#0000FF",None,50)]


ball=Ball(None,None,None,-3.14159265/2,0.01,1,1)



root=tk.Tk()
root.geometry("900x700")

canvas=tk.Canvas(root,width=900,height=700,bg="white")
canvas.place(x=0,y=0)

canvas.bind("<Button-1>",ball.click)

def loop():
    for a in balls:
        a.move()
    Balls.bound()
    root.after(1,loop)

def loop2():
    ball.click_and_move()
    root.after(1,loop2)

loop()
loop2()

root.mainloop()